#### Beyond Linux® From Scratch (systemd Edition) - Version r13.0-491

### Chapter 33. GNOME Libraries and Desktop

- Prev

  tinysparql-3.11.1

- Next

  GSound-1.0.3

- Up
- Home

# localsearch-3.11.1

## Introduction to Localsearch

The Localsearch package contains a filesystem indexer as well as a metadata extractor.

### Note

Development versions of BLFS may not build or run some packages properly if LFS or dependencies have been updated since the most recent stable versions of the books.

### Package Information

- Download (HTTP): https://download.gnome.org/sources/localsearch/3.11/localsearch-3.11.1.tar.xz

- Download MD5 sum: 1406955c072af72776fdcbb9b12dc103

- Download size: 4.3 MB

- Estimated disk space required: 79 MB

- Estimated build time: 0.2 SBU (with parallelism=4; add as much as 1.3 SBU for tests, dependent on disk speed)

### Localsearch Dependencies

#### Required

gexiv2-0.16.0, gst-plugins-base-1.28.2, and tinysparql-3.11.1

#### Recommended

Exempi-2.6.6, giflib-6.1.3, FFmpeg-8.1, ICU-78.3, libexif-0.6.26, libgxps-0.3.2, libseccomp-2.6.0, libwebp-1.6.0, Poppler-26.04.0, and UPower-1.91.2

#### Optional

asciidoc-10.2.1 (to build manual pages; note that manual pages are required for some tests), CMake-4.3.2, gst-plugins-good-1.28.2 (for one test), libgsf-1.14.57, dbusmock-0.38.1 (for functional tests), totem-pl-parser-3.26.7, libcue, libitpcdata, libosinfo, and gupnp

## Kernel Configuration

Enable the following options in the kernel configuration, then recompile the kernel and reboot if necessary:

    Security options --->
      [*]        Enable different security models                         [SECURITY]
      [*]        Landlock support                                [SECURITY_LANDLOCK]
      # List more Linux Security Modules here (separated with comma) if needed,
      # for example 'landlock,lockdown,smack':
      (landlock) Ordered list of enabled LSMs                                  [LSM]

## Installation of Localsearch

### Warning

If you are upgrading this package from a version where it was known as tracker-miners, there are several files which will cause conflicts. Before installing this package, remove these files as the `root` user:

    rm -fv /etc/xdg/autostart/tracker-miner-fs-3.desktop                           &&
    rm -fv /usr/lib/systemd/user/tracker-miner-fs-3.service                        &&
    rm -fv /usr/lib/systemd/user/tracker-miner-fs-control-3.service                &&
    rm -fv /usr/share/dbus-1/services/org.freedesktop.Tracker3.Miner.Files.service &&
    rm -fv /usr/share/dbus-1/services/org.freedesktop.Tracker3.Writeback.service   &&
    rm -fv /usr/share/dbus-1/services/org.freedesktop.Tracker3.Miner.Files.Control.service

### Note

If you plan to run the tests, some timeouts are too short when using spinning disks. There are two places where timeouts are used: first, individual tests inside a group of tests have a default timeout of 10s. This can be changed by setting the environment variable `TRACKER_TESTS_AWAIT_TIMEOUT` to the desired value when running the tests (see below). Second, a global timeout for a group of tests is fixed at configuration time. The default value in the `functional-tests` directory (other directories have only short lived tests) may be increased with the following command (replace 200 with a value suitable for your machine):

    sed -i s/120/200/ tests/functional-tests/meson.build

Install Localsearch by running the following commands:

    mkdir build &&
    cd    build &&

    meson setup --prefix=/usr             \
                --buildtype=release       \
                -D man=false              \
                -D functional_tests=false \
                ..                        &&
    ninja

To test the results, issue the following commands. Make sure that you adjust the individual test timeout to a value suitable for your machine, please read the note above for more details.

    meson configure -D man=true -D functional_tests=true &&
    ninja                                                &&
    dbus-run-session env LC_ALL=C.UTF-8 TRACKER_TESTS_AWAIT_TIMEOUT=20 \
                     ninja test

Now, as the `root` user:

    ninja install

## Command Explanations

`--buildtype=release`: Specify a buildtype suitable for stable releases of the package, as the default may produce unoptimized binaries.

`-D man=false`: This switch prevents the build process from generating man pages. Omit this switch if you have asciidoc-10.2.1 installed and wish to generate and install the man pages.

`-D functional_tests=false`: This switch prevents the setup process to require dbusmock-0.38.1 and fail if it is not installed. You can remove this switch if it is installed.

`-D seccomp=false`: This option disables the seccomp system call filter. On some architectures, such as ARM, the functions that localsearch uses are not guarded properly, and localsearch will get killed with a SIGSYS signal as a result of this. Note that disabling seccomp may cause the system to be compromised worse in the event that a security vulnerability in localsearch or its dependencies is exploited, and it is NOT recommended.

`-D landlock=disabled`: This switch disables the Landlock file access sandbox. Use it if you don't want to build the kernel with Landlock support. Note that disabling Landlock may cause the system to be compromised worse in the event that a security vulnerability in localsearch or its dependencies is exploited, and this is NOT recommended.

`-D battery_detection=none`: Use this option if you have not installed the recommended dependency upower. Do not use this option if your system has a battery (laptop battery or UPS), or else localsearch may waste battery life when A/C power is unavailable.

`-D libav=disabled`: Use this option if you have not installed the recommended dependency ffmpeg. Note that using this will cause 7 test failures, and will also significantly hamper the functionality of this package.

## Contents

Installed Programs: localsearch
Installed Libraries: Several modules under /usr/lib/localsearch-3.0
Installed Directories: /usr/lib/localsearch-3.0 and /usr/share/localsearch3

### Short Descriptions

localsearch | starts, stops, restarts, and lists daemons responsible for indexing content

- Prev

  tinysparql-3.11.1

- Next

  GSound-1.0.3

- Up
- Home